VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetTickCount Lib "kernel32" () As Long

Private Type TimeExp
  Bubble As Long
  Exchange As Long
  Heap As Long
  Insertion As Long
  Quick As Long
  Shelll As Long
End Type

Private Sub Form_Load()
  Dim a As New Sorting, i As Long, MyArr(-800 To 4000), Reserve(-800 To 4000)
  Dim StartTime As Long
  Dim TotalRanks As TimeExp
  
  For i = LBound(MyArr) To UBound(MyArr)
    MyArr(i) = Rnd * 800
    Reserve(i) = MyArr(i)
  Next
  
  Randomize Timer
  
  '  .   ,    
  'StartTime = GetTickCount
  'a.BubbleSort MyArr
  'TotalRanks.Bubble = GetTickCount - StartTime
  'RestoreArr Reserve(), MyArr()
  
  StartTime = GetTickCount
  a.ExchangeSort MyArr
  TotalRanks.Exchange = GetTickCount - StartTime
  RestoreArr Reserve(), MyArr()
  
  StartTime = GetTickCount
  a.HeapSort MyArr
  TotalRanks.Heap = GetTickCount - StartTime
'  SaveArr App.Path + "\Heap.txt", MyArr()
  RestoreArr Reserve(), MyArr()
  
  StartTime = GetTickCount
  a.InsertionSort MyArr
  TotalRanks.Insertion = GetTickCount - StartTime
  RestoreArr Reserve(), MyArr()
  
  StartTime = GetTickCount
  a.QuickSort MyArr, LBound(MyArr), UBound(MyArr)
  TotalRanks.Quick = GetTickCount - StartTime
  RestoreArr Reserve(), MyArr()
  
  StartTime = GetTickCount
  a.ShellSort MyArr
  TotalRanks.Shelll = GetTickCount - StartTime
'  SaveArr App.Path + "\Shell.txt", MyArr()
  
  MsgBox "!  :" & vbNewLine & vbNewLine & "    " & TotalRanks.Bubble & vbNewLine & _
                                                          "      " & TotalRanks.Exchange & vbNewLine & _
                                                          "       " & TotalRanks.Heap & vbNewLine & _
                                                          "    " & TotalRanks.Insertion & vbNewLine & _
                                                          "    " & TotalRanks.Quick & vbNewLine & _
                                                          "Shell      " & TotalRanks.Shelll & vbNewLine

End Sub

Private Sub RestoreArr(From(), Where())
  Dim i As Long
  For i = LBound(From) To UBound(From)
    Where(i) = From(i)
  Next
End Sub

Private Sub SaveArr(FName As String, Arr())
  Dim i As Long, FNum As Integer
  FNum = FreeFile
  Open FName For Output As #FNum
  For i = LBound(Arr) To UBound(Arr)
    Write #FNum, Arr(i)
  Next
  Close #FNum
End Sub
